#include <iostream>
#define size 201
using namespace std;
int to_index(int v);
void isReachableDestinations (bool R[100], int n, int T[100][2], bool map[size][size]);

int main()
{
	int n = 0, m = 0;					// number of destination n, closed road m
	int T[100][2] = {0};				// destination point
	bool R[100] = {false};				// return reachableD estinations
	int x1 = 0, y1 = 0, x2 = 0, y2 =0;	// two endpoints of closed road
	bool map[size][size] = {false};		// city

	while (cin >> n >> m)
	{
		// init map
		for (int u = 0; u < size; u++)
		{
			for (int v = 0; v < size; v++)
				map[u][v] = false;
		}

		// set destination point
		for (int i = 0; i < n; i++)
			cin >> T[i][0] >> T[i][1];

		// draw the map of city
		for (int i = 1; i <= m; i++)
		{
			cin >> x1 >> y1 >> x2 >> y2;

			if (x1 == x2 && y2 >= y1)
			{
				for (int k = y1; k <= y2; k++)
					map[to_index(x1)][to_index(k)] = true;
			}
			else if (x1 == x2 && y2 < y1)
			{
				for (int k = y2; k <= y1; k++)
					map[to_index(x1)][to_index(k)] = true;
			}
			else if (y1 == y2 && x2 >= x1)
			{
				for (int k = x1; k <= x2; k++)
					map[to_index(k)][to_index(y1)] = true;
			}
			else if (y1 == y2 && x2 < x1)
			{
				for (int k = x2; k <= x1; k++)
					map[to_index(k)][to_index(y1)] = true;
			}
		}

		isReachableDestinations(R, n, T, map);

		// print result
		for (int i = 0; i < 100 ; i++)
		{
			if (R[i])
			{
				cout << i+1 << " ";
				R[i] = false;
			}
		}

		cout << endl;
	}

	return 0;
}

int to_index(int v)
{
	return v+(size-1)/2;
}

void isReachableDestinations (bool R[100], int n, int T[100][2], bool map[size][size])
{
	bool isReachable1 = true, isReachable2 = true;

	for (int i = 0; i < n; i++)
	{
		isReachable1 = true;
		isReachable2 = true;

		if (T[i][0] >= 0 && T[i][1] >= 0) // +, +
		{
			// 先往右，再向上
			for (int x = 0; x <= T[i][0]; x++)
			{
				if (map[to_index(x)][to_index(0)]) // 向右走
					isReachable1 = false;					
			}
			for (int y = 0; y <= T[i][1]; y++)
			{
				if (map[to_index(T[i][0])][to_index(y)])  // 向上走
					isReachable1 = false;
			}
			// 先往上，再向右
			for (int y = 0; y <= T[i][1]; y++)
			{
				if (map[to_index(0)][to_index(y)])  // 向上走
					isReachable2 = false;
			}
			for (int x = 0; x <= T[i][0]; x++)
			{
				if (map[to_index(x)][to_index(T[i][1])]) // 向右走
					isReachable2 = false;					
			}
		}	// end +, +
		else if (T[i][0] >= 0 && T[i][1] <= 0) // +, -
		{
			// 先往右，再向上
			for (int x = 0; x <= T[i][0]; x++)
			{
				if (map[to_index(x)][to_index(0)]) // 向右走
					isReachable1 = false;					
			}
			for (int y = T[i][1]; y <= 0; y++)
			{
				if (map[to_index(T[i][0])][to_index(y)])  // 向上走
					isReachable1 = false;
			}
			// 先往上，再向右
			for (int y = T[i][1]; y <= 0; y++)
			{
				if (map[to_index(0)][to_index(y)])  // 向上走
					isReachable2 = false;
			}
			for (int x = 0; x <= T[i][0]; x++)
			{
				if (map[to_index(x)][to_index(T[i][1])]) // 向右走
					isReachable2 = false;				
			}
		} // end +, -			
		else if (T[i][0] <= 0 && T[i][1] >= 0) // -, +
		{
			// 先往右，再向上
			for (int x = T[i][0]; x <= 0; x++)
			{
				if (map[to_index(x)][to_index(0)]) // 向右走
					isReachable1 = false;				
			}
			for (int y = 0; y <= T[i][1]; y++)
			{
				if (map[to_index(T[i][0])][to_index(y)])  // 向上走
					isReachable1 = false;
			}
			// 先往上，再向右
			for (int y = 0; y <= T[i][1]; y++)
			{
				if (map[to_index(0)][to_index(y)])  // 向上走
					isReachable2 = false;
			}
			for (int x = T[i][0]; x <= 0; x++)
			{
				if (map[to_index(x)][to_index(T[i][1])]) // 向右走
					isReachable2 = false;				
			}
		}	// end -, +
		else if (T[i][0] <= 0 && T[i][1] <= 0) // -, -
		{
			// 先往右，再向上
			for (int x = T[i][0]; x <= 0; x++)
			{
				if (map[to_index(x)][to_index(0)]) // 向右走
					isReachable1 = false;				
			}
			for (int y = T[i][1]; y <= 0; y++)
			{
				if (map[to_index(T[i][0])][to_index(y)])  // 向上走
					isReachable1 = false;
			}
			// 先往上，再向右
			for (int y = T[i][1]; y <= 0; y++)
			{
				if (map[to_index(0)][to_index(y)])  // 向上走
					isReachable2 = false;
			}
			for (int x = T[i][0]; x <= 0; x++)
			{
				if (map[to_index(x)][to_index(T[i][1])]) // 向右走
					isReachable2 = false;					
			}
		}	 // end -, -
		if (isReachable1 or isReachable2)
			R[i] = true;

	} // end i loop
}